﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FileMonitor.Service.Prototype;

namespace FileMonitor.Service.Tracking
{
    public enum TaskType
    {
        StartProcess,
        StopProcess,
        NewBatch,
        EndBatch,
        NewFile,
        EndFile,
        ErrorFile
    }
    public class TrackingTask
    {
        private FileMonitorBase _process;
        //private string _filePath;
        private TaskType _taskType;

        public TrackingTask(FileMonitorBase process,TaskType taskType)
        {
            //this._filePath = filePath;
            this._process = process;
            this._taskType = taskType;
        }

        public TaskType TaskType
        {
            get { return this._taskType; }
        }
        
        public FileMonitorBase Process
        {
            get { return this._process; }
        }

        public string FilePath
        {
            get;
            set;
        }

        public Exception Exception
        {
            get;
            set;
        }

        public string BatchID
        {
            get;
            set;
        }

    }
}
