﻿using System;
using System.IO;
using ICSharpCode.SharpZipLib.Zip;
namespace FileUtility.ZIP
{
    public class UnZip
    {
        public string UnZipFile(string TargetFile, string fileDir,bool auotoExtension)
        {
            string rootFile = " ";
            try
            {
                //读取压缩文件(zip文件)，准备解压缩
                using (ZipInputStream s = new ZipInputStream(File.OpenRead(TargetFile.Trim())))
                {
                    ZipEntry theEntry;
                    string path = fileDir;
                    //解压出来的文件保存的路径

                    string rootDir = " ";
                    //根目录下的第一个子文件夹的名称
                    while ((theEntry = s.GetNextEntry()) != null)
                    {
                        rootDir = Path.GetDirectoryName(theEntry.Name);
                        //得到根目录下的第一级子文件夹的名称
                        if (rootDir.IndexOf("\\") >= 0)
                        {
                            rootDir = rootDir.Substring(0, rootDir.IndexOf("\\") + 1);
                        }
                        string dir = Path.GetDirectoryName(theEntry.Name);
                        //根目录下的第一级子文件夹的下的文件夹的名称
                        string fileName = Path.GetFileName(theEntry.Name);
                        //根目录下的文件名称
                        if (dir != " ")
                        //创建根目录下的子文件夹,不限制级别
                        {
                            if (!Directory.Exists(fileDir + "\\" + dir))
                            {
                                path = fileDir + "\\" + dir;
                                //在指定的路径创建文件夹
                                Directory.CreateDirectory(path);
                            }
                        }
                        else if (dir == " " && fileName != "")
                        //根目录下的文件
                        {
                            path = fileDir;
                            rootFile = fileName;
                        }
                        else if (dir != " " && fileName != "")
                        //根目录下的第一级子文件夹下的文件
                        {
                            if (dir.IndexOf("\\") > 0)
                            //指定文件保存的路径
                            {
                                path = fileDir + "\\" + dir;
                            }
                        }

                        if (dir == rootDir)
                        //判断是不是需要保存在根目录下的文件
                        {
                            path = fileDir + "\\" + rootDir;
                        }

                        //以下为解压缩zip文件的基本步骤
                        //基本思路就是遍历压缩文件里的所有文件，创建一个相同的文件。
                        if (fileName != String.Empty)
                        {
                            if (auotoExtension)
                            {
                                if (fileName.IndexOf(".") < 0)
                                {
                                    string extName = ".txt";
                                    if (fileName.Length >= 3)
                                    {
                                        extName = "." + fileName.Substring(0, 3);
                                    }
                                    string dateStr = System.DateTime.Now.ToString("yyyyMMdd");
                                    fileName = fileName + "_" + dateStr + extName;
                                }
                            }
                            using (FileStream streamWriter = File.Create(path + "\\" + fileName))
                            {

                                int size = 2048;
                                byte[] data = new byte[2048];
                                while (true)
                                {
                                    size = s.Read(data, 0, data.Length);
                                    if (size > 0)
                                    {
                                        streamWriter.Write(data, 0, size);
                                    }
                                    else
                                    {
                                        break;
                                    }
                                }
                            }

                            //   streamWriter.Close();
                        }
                    }
                    s.Close();
                }
                return rootFile;
            }
            catch (Exception ex)
            {
                return "1; " + ex.Message;
            }
        }   
    }
}
